
/*** Generated through Lumonix shaderFX  by: Andry in 3dsmax at: 13.09.2007 18:12:48  ***/ 

// This FX shader was built to support FX Composer. 


texture TextureMap_880
<
	string ResourceName = "N_cobblestones_ati.bmp";
	string UIName = "Texture Map";
	string ResourceType = "2D";
>;
 
sampler2D TextureMap_880Sampler = sampler_state
{
	Texture = <TextureMap_880>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};
 
float OffsetBias
<
	string UIWidget = "slider";
	float UIMin = 0.0;
	float UIMax = 0.2;
	float UIStep = 0.001;
	string UIName = "Offset Bias";
> = 0.04;
 
texture TextureMap_1
<
	string ResourceName = "D_cobblestones.dds";
	string UIName = "Texture Map";
	string ResourceType = "2D";
>;
 
sampler2D TextureMap_1Sampler = sampler_state
{
	Texture = <TextureMap_1>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};
 
texture NormalMap_8068
<
	string ResourceName = "N_cobblestones_ati.bmp";
	string UIName = "Normal Map";
	string ResourceType = "2D";
>;
 
sampler2D NormalMap_8068Sampler = sampler_state
{
	Texture = <NormalMap_8068>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};
 


/************** light info **************/ 

float3 light1Pos : POSITION 
< 
	string Object = "PointLight"; 
	string Space = "World"; 
> = {0.0f, 10.0f, -30.0f}; 

//---------------------------------- 

float4 light1Color  : SPECULAR 
< 
	string UIName =  "Light1 Color"; 
	string Object = "Pointlight"; 
	string UIWidget = "Color"; 
> = { 1.0f, 1.0f, 1.0f, 1.0f}; 

//---------------------------------- 

float4x4 wvp : WorldViewProjection < string UIWidget = "None"; >;  
float4x4 worldI : WorldInverse < string UIWidget = "None"; >;  
float4x4 worldIT : WorldInverseTranspose < string UIWidget = "None"; >;  
float4x4 viewInv : ViewInverse < string UIWidget = "None"; >;  
float4x4 world : World < string UIWidget = "None"; >;  
 

// input from application 
	struct a2v { 
	float4 position		: POSITION; 
	float3 tangent		: TANGENT; 
	float3 binormal		: BINORMAL; 
	float3 normal		: NORMAL; 

	float2 texCoord		: TEXCOORD0; 

}; 

// output to fragment program 
struct v2f { 
        float4 position    		: POSITION; 
        float3 lightVec    		: TEXCOORD0; 

		float2 texCoord			: TEXCOORD1; 
        float3 eyeVec	    	: TEXCOORD2; 

}; 

//Diffuse and Specular Pass Vertex Shader
v2f v(a2v In, uniform float3 lightPosition) 
{ 
	v2f Out = (v2f)0; 
    Out.position = mul(In.position, wvp);				//transform vert position to homogeneous clip space 
    //this code was added by the standard material 
    float3x3 objTangentXf;								//build object to tangent space transform matrix 
    	objTangentXf[0] = In.tangent; 
    	objTangentXf[1] = -In.binormal; 
    	objTangentXf[2] = In.normal; 
    //this code was added by the standard material 
    float3 osLPos = mul(lightPosition, worldI);			//put world space light position in object space 
    float3 osLVec = osLPos.xyz - In.position.xyz;		//object space light vector 
    Out.lightVec = mul(objTangentXf, osLVec);			//tangent space light vector passed out 

	//this code was added by the texture map Node 
    Out.texCoord = In.texCoord;						//pass through texture coordinates from channel 1 
	//these three lines were added by the Eye Vector Node 
    float4 osIPos = mul(viewInv[3], worldI);			//put world space eye position in object space 
    float3 osIVec = osIPos.xyz - In.position.xyz;		//object space eye vector 
    Out.eyeVec = mul(objTangentXf, osIVec);				//tangent space eye vector passed out 

    return Out; 
} 

//Diffuse and Specular Pass Pixel Shader
float4 f(v2f In, uniform float4 lightColor) : COLOR 
{ 
	float3 ret = float3(0,0,0); 
	float3 L = normalize(In.lightVec);		//creating the light vector  

	float4 TextureMap_880 = tex2D(TextureMap_880Sampler, In.texCoord.xy);
	float Two = 2.0; 
	float TimesTwo = TextureMap_880.a * Two;
	float One = 1.0; 
	float MinusOne = TimesTwo - One;
    float3 INEyeVec_851 = In.eyeVec.xyz;		//unnormalized eye vector 
	INEyeVec_851 = normalize(INEyeVec_851); 
    //invert eye vector Y 
    	INEyeVec_851.y = -INEyeVec_851.y; 
	float2 HeightTimesV = MinusOne * INEyeVec_851;
	float2 OffsetResult = HeightTimesV * OffsetBias;
	float2 OriginalTexCoords = In.texCoord.xy; 
	float2 OffsetTexCoords = OffsetResult + OriginalTexCoords;
	float4 TextureMap_1 = tex2D(TextureMap_1Sampler, OffsetTexCoords.xy);
	float3 input2 = TextureMap_1.rgb; 


	float4 NormalMap_8068 = tex2D(NormalMap_8068Sampler, OffsetTexCoords.xy);
	NormalMap_8068.xyz = NormalMap_8068.xyz * 2 - 1;		//expand to -1 to 1 range 
	NormalMap_8068.rgb = normalize(NormalMap_8068.rgb); 		//normalized the normal vector 
	float3 input8 = NormalMap_8068.rgb; 

	float3 N = input8;						//using the Normal socket  
	float3 diffuseColor = input2;			//using the Diffuse Color socket  
	float diffuse = saturate(dot(N,L));		//calculate the diffuse  
	diffuseColor *= diffuse;				//the resulting diffuse color  
	ret += diffuseColor;					//add diffuse light to final color  
	ret *= lightColor;						//multiply by the color of the light 
	float4 done = float4(ret, 1); 
	return done; 
} 

technique Complete  
{  
	pass light1  
    {		 
	VertexShader = compile vs_1_1 v(light1Pos); 
	ZEnable = true; 
	CullMode = ccw; 
	ZWriteEnable = true; 
	DestBlend = One; 
	AlphaBlendEnable = false; 
	PixelShader = compile ps_2_0 f(light1Color); 
	}  

}  

