
Include "b3d_dx9.bb"
xGraphics3D 800, 600, 32, 0,1


xSetTextureFiltering TF_ANISOTROPIC

;camera
Global camera = xCreateCamera()
xPositionEntity camera, 0, 30, -160
xRotateEntity camera, 10, 0, 0

;Light
light = xCreateLight()
xpositionEntity light, 10, 20, -60
xRotateEntity light, 10, 20, -60

pl= xCreateCube ()
xScaleEntity pl, 100,0.001,100
xEntityColor pl,200,0,0

; physical world
pxCreateWorld(1,"key")
pxSetGravity(0, -10, 0)

; create Soft Body
mesh = xLoadMesh ("../PhysX media/teapot_SB.b3d")
xFlipMesh mesh
xGetMeshVB(mesh)
VB_size = xGetMeshVBSize(mesh)
SB = pxCreateSoftBody("../PhysX media/teapot.obj", "../PhysX media/teapot_SB.tet", xGetMeshVB(mesh), xGetMeshVBSize(mesh), 0, 60, 0,  0,0,0)
pxSoftBodySetStretchingStiffness(SB%, 0.01)

; soft body core
sp_body = pxBodyCreateSphere(7, 30)
pxBodySetPosition(sp_body,0, 60, 0)
pxSoftBodyAttachToShape(SB%, sp_body%,0)

;cube
cube = xCreateCube ()
xScaleEntity cube,8,8,8
cube_body = pxBodyCreateCube(8,8,8,10)
pxBodySetPosition(cube_body,0,40,0)
pxBodySetRotation(cube_body,0,40,0)



;effect
Global  brushedmetal = xLoadFXFile("../PhysX media/bump2.fx")

If xValidateEffectTechnique(brushedmetal, "Complete") = False
	RuntimeError "Technique does not supported!"
EndIf

;textures
Global tex1 = xLoadTexture("../PhysX media/N_cobblestones_ati.bmp")
Global tex2 = xLoadTexture("../PhysX media/D_cobblestones.bmp")

xSetEntityEffect mesh, brushedmetal
xSetEffectTechnique(mesh, "Complete")
xSetEffectMatrixSemantic mesh, "wvp", WORLDVIEWPROJ
xSetEffectMatrixSemantic mesh, "worldI", WORLDINVERSE
xSetEffectMatrixSemantic mesh, "worldIT", WorldInverseTranspose
xSetEffectMatrixSemantic mesh, "viewInv", VIEWINVERSE
xSetEffectMatrixSemantic mesh, "world", WORLD

xSetEffectTexture mesh, "TextureMap_880", tex1
xSetEffectTexture mesh, "NormalMap_8068", tex1
xSetEffectTexture mesh, "TextureMap_1", tex2


k = 1

; 
While Not xKeyDown(1) Or xWinMessage("WM_CLOSE")
	
	; 
	If xKeyHit(KEY_SPACE)  Then Create_SB():k=k+1

time=MilliSecs ()
	pxRenderPhysic(30,0)
	xUpdatePhysxPose cube
    pxDX9BodySetEntity(cube, cube_body)
	UpdateSoftBody(mesh%, SB%)
	Update_SB()
New_time=MilliSecs ()-time

	xUpdateWorld()
	xRenderWorld()
	
	;text
	xText 10, 10, "FPS: " + xGetFPS()+"  DLL Time: "+ New_time
	xText 10, 30, "Space - add Soft Body"
	xText 10, 60, "amount: "+k

	xFlip

Wend


Type Px_SoftBody
	Field SB_body%
	Field SB_mesh%
End Type

Function Create_SB()
   ocu.Px_SoftBody = New Px_SoftBody
		ocu\SB_mesh = xLoadMesh ("../PhysX media/teapot_SB.b3d")
		xFlipMesh ocu\SB_mesh
		ocu\SB_body = pxCreateSoftBody("../PhysX media/teapot.obj", "../PhysX media/teapot_SB.tet", xGetMeshVB(ocu\SB_mesh), xGetMeshVBSize(ocu\SB_mesh), 0, 60, 0,  0,0,0)
		pxSoftBodySetStretchingStiffness(ocu\SB_body, 0.01)

		sp_body = pxBodyCreateSphere(7, 30)
		pxBodySetPosition(sp_body,0, 60, 0)
		pxSoftBodyAttachToShape(ocu\SB_body%, sp_body%,0)



xSetEntityEffect ocu\SB_mesh, brushedmetal
xSetEffectTechnique(ocu\SB_mesh, "Complete")
xSetEffectMatrixSemantic ocu\SB_mesh, "wvp", WORLDVIEWPROJ
xSetEffectMatrixSemantic ocu\SB_mesh, "worldI", WORLDINVERSE
xSetEffectMatrixSemantic ocu\SB_mesh, "worldIT", WorldInverseTranspose
xSetEffectMatrixSemantic ocu\SB_mesh, "viewInv", VIEWINVERSE
xSetEffectMatrixSemantic ocu\SB_mesh, "world", WORLD

xSetEffectTexture ocu\SB_mesh, "TextureMap_880", tex1
xSetEffectTexture ocu\SB_mesh, "NormalMap_8068", tex1
xSetEffectTexture ocu\SB_mesh, "TextureMap_1", tex2
 End Function

Function UpdateSoftBody(mesh%, SB%)

	pxUpdateSoftBody(SB)
	
	nvert = xGetMeshVBSize(mesh)
	pvbank = pxBufferCreate(nvert*3)
	nbank = pxBufferCreate(nvert*3)
	pxSoftBodyGetVertexPos(SB, pvbank, nvert)
	pxSoftBodyGetNormals(SB, nbank, nvert)

	xUpdateMeshVBPositions(mesh%, pvbank%)
	xUpdateMeshVBNormals(mesh%, nbank%)

	pxBufferDelete(pvbank)
	pxBufferDelete(nbank)
End Function

Function Update_SB()
	For ocu.Px_SoftBody = Each Px_SoftBody
		pxUpdateSoftBody(ocu\SB_body)
        UpdateSoftBody(ocu\SB_mesh, ocu\SB_body)
	Next
End Function

